/* $VER: TechReport.rexx 1.0c (01.11.94)
   Copyright 1994 Soft-Logik Publishing Corporation
   May not be distributed without Soft-Logik Publishing Corporation's express written permission */

/* SAME OLD STUFF */
OPTIONS RESULTS
TRACE OFF
ADDRESS COMMAND
/* Make sure rexx support is opened */
IF ~SHOW('L','rexxsupport.library') THEN
   CALL ADDLIB('rexxsupport.library',0,-30)

/* DEFINITIONS AND REPORT SETUP */
ofilename='ram:Report.TEXT'
tfilename='t:Report.TEMP'

if ~open(.ofile, ofilename, 'W') then return 9
call writeln(.ofile, 'PAGESTREAM 3.0 TECHNICAL SUPPORT REPORT')
call writeln(.ofile, '---------------------------------------')

ADDRESS PAGESTREAM
openbusyrequester message "'Preparing report...'" thermometer enabled abort enabled total 100 current 0
bh=result
ADDRESS COMMAND


/* MAIN LOOP */
call REGINFO()
call SETBUSY (2)
call SYSTEMINFO()
call SETBUSY (5)
call HELPSYSTEM()
call SETBUSY (8)
call ASSIGNS()
call SETBUSY (10)
call PROGRAMS()
call SETBUSY (30)
call LIBS()
call SETBUSY (35)
call FILTERS()
call SETBUSY (65)
call EFFECTS()
call SETBUSY (80)
call ENGINES()
call SETBUSY (95)
call COLORS()
call SETBUSY (100)
call CLEANUP(0)


REGINFO:
call writeln(.ofile, '')
call writeln(.ofile, 'USER INFORMATION:')
if ~open(.tfile, 'PageStream3:PageStream3.prefs', 'R') then rcode=9
    else rcode=0
user.name='Unknown'
user.comp='Unknown'
user.regn='Unknown'
if rcode=0 then do
    do until eof(.tfile)
        temp=(readln(.tfile))
        if left(temp,8)='USERNAME' then user.name=left(right(temp,length(temp)-10),length(temp)-11)
        if left(temp,8)='USERCOMP' then user.comp=left(right(temp,length(temp)-13),length(temp)-14)
        if left(temp,8)='USERREGN' then parse var temp dum user.regn .
    end
    call close(.tfile)
end
call writeln(.ofile, '  User Name................. '||user.name)
call writeln(.ofile, '  Company................... '||user.comp)
call writeln(.ofile, '  Registration Number....... '||user.regn)
return rcode

SYSTEMINFO:
call writeln(.ofile, '')
call writeln(.ofile, 'SYSTEM INFORMATION:')
'version >'||tfilename
temp=GETTEMP()
call writeln(.ofile, '  '||temp)
'cpu >'||tfilename
temp=GETTEMP()
call writeln(.ofile, '  '||temp)
call writeln(.ofile, '')
'avail >'||tfilename
if ~open(.tfile, tfilename, 'R') then return 9
do 4
    temp=readln(.tfile)
    call writeln(.ofile, '  '||temp)
end
call close(.tfile)
return

HELPSYSTEM:
call writeln(.ofile, '')
call writeln(.ofile, 'HELP SYSTEM:')
if exists('libs:amigaguide.library') then do
    'version libs:amigaguide.library >'||tfilename
    temp=GETTEMP()
    parse var temp dum ver .
    call writeln(.ofile, '  AmigaGuide.library........ v'||ver)
end
else call writeln(.ofile, '  AmigaGuide.library........ MISSING!')
if exists('sys:Utilities/AmigaGuide') then do
    'version sys:utilities/amigaguide >'||tfilename
    temp=GETTEMP()
    parse var temp dum ver .
    call writeln(.ofile, '  AmigaGuide program........ v'||ver)
    agflag=1
end
else agflag=0
if exists('sys:Utilities/Multiview') then do
    'version sys:utilities/multiview >'||tfilename
    temp=GETTEMP()
    parse var temp dum ver .
    call writeln(.ofile, '  MultiView program......... v'||ver)
    mvflag=1
end
else mvflag=0
if agflag=0 & mvflag=0 then call writeln(.ofile, '  AmigaGuide/Multiview...... MISSING!')
return

ASSIGNS:
call writeln(.ofile, '')
call writeln(.ofile, 'ASSIGNS: (AmigaDOS assigns)')

/* find out if the softlogik: assign was made */
slassign=showlist('a','SOFTLOGIK')
if slassign=1 then do
    'assign SoftLogik: exists >'||tfilename
    if ~open(.tfile, tfilename, 'R') then return 9
    temp=(readln(.tfile))
    if pos('SOFTLOGIK',upper(temp))~=0 then do
        parse var temp dum line
        line=strip(line,'b')
        call writeln(.ofile, '  SoftLogik................. '||line)
    end
    call close(.tfile)
end
else call writeln(.ofile, '  SoftLogik................. SoftLogik: ASSIGN NOT MADE!')

/* find out if the pagestream3: assign was made */
pgsassign=showlist('a','PAGESTREAM3')
if pgsassign=1 then do
    'assign PageStream3: exists >'||tfilename
    if ~open(.tfile, tfilename, 'R') then return 9
    temp=(readln(.tfile))
    if pos('PAGESTREAM3',upper(temp))~=0 then do
        parse var temp dum line
        line=strip(line,'b')
        call writeln(.ofile, '  PageStream3............... '||line)
    end
    call close(.tfile)
end
else call writeln(.ofile, '  PageStream3............... PageStream3: ASSIGN NOT MADE!')

/* find out if the fonts assign addition was made */
'assign fonts: exists >'||tfilename
if ~open(.tfile, tfilename, 'R') then return 9
line=nul
do until eof(.tfile)
    temp=(readln(.tfile))
    if pos('SOFTLOGIK',upper(temp))~=0 & pos('FONTS',upper(temp))~=0 then line=right(temp,length(temp)-pos('+',temp)-1)
end
if line=nul then call writeln(.ofile, '  Fonts..................... SoftLogik:Fonts add ASSIGN NOT MADE!')
call close(.tfile)
call writeln(.ofile, '  Fonts..................... '||line||' add')
return

PROGRAMS:
call writeln(.ofile, '')
call writeln(.ofile, 'PROGRAM FILES:')
if exists('PageStream3:PageStream3') then do
    'version PageStream3:PageStream3 >'||tfilename
    temp=GETTEMP()
    parse var temp dum ver ver2 .
    /* for technical reasons, PageStream has version numbers of PageStream3 1.0 instead of PageStream 3.0. Let's make it easier on the user by changing this for the report. */
    ver='3'||right(ver,length(ver)-1)
	if ver2='' then ver2=' '
    call writeln(.ofile, '  PageStream3 program....... v'||ver||' 'ver2)
end
else call writeln(.ofile, '  PageStream3 program....... MISSING!')
if exists('PageStream3:BME') then do
    'version PageStream3:BME >'||tfilename
    temp=GETTEMP()
    parse var temp dum ver ver2 .
	if ver2='' then ver2=' '
    call writeln(.ofile, '  BME program............... v'||ver||' 'ver2)
end
else call writeln(.ofile, '  BME program............... MISSING!')
if exists('PageStream3:PageLiner') then do
    'version PageStream3:PageLiner >'||tfilename
    temp=GETTEMP()
    parse var temp dum ver ver2 .
	if ver2='' then ver2=' '
    call writeln(.ofile, '  PageLiner program......... v'||ver||' 'ver2)
end
else call writeln(.ofile, '  PageLiner program......... MISSING!')
return

LIBS:
call writeln(.ofile, '')
call writeln(.ofile, 'SOFTLOGIK:LIBS (program libraries)')
if exists('SoftLogik:Libs/softlogik_app.library') then 'version SoftLogik:Libs/softlogik_app.library >'||tfilename
temp=GETTEMP()
parse var temp dum ver .
call writeln(.ofile, '  softlogik_app.library..... v'||ver)
if exists('SoftLogik:Libs/softlogik_obj.library') then 'version SoftLogik:Libs/softlogik_obj.library >'||tfilename
temp=GETTEMP()
parse var temp dum ver .
call writeln(.ofile, '  softlogik_obj.library..... v'||ver)
if exists('SoftLogik:Libs/slarexxsupport.library') then 'version SoftLogik:Libs/slarexxsupport.library >'||tfilename
temp=GETTEMP()
parse var temp dum ver .
call writeln(.ofile, '  slarexxsupport.library.... v'||ver)
return

FILTERS:
call writeln(.ofile, '')
call writeln(.ofile, 'SOFTLOGIK:FILTERS (filter modules)')
if exists('SoftLogik:filters') then do
    call GETFILES('softlogik:filters')
    call SAYVERS('softlogik:filters')
    end
else do
    call writeln(.ofile, '- Filters directory MISSING!')
end
return

EFFECTS:
call writeln(.ofile, '')
call writeln(.ofile, 'SOFTLOGIK:EFFECTS (effect modules)')
if exists('SoftLogik:effects') then do
    call GETFILES('softlogik:effects')
    call SAYVERS('softlogik:effects')
    end
else do
    call writeln(.ofile, '- Effects directory MISSING!')
end

/* PRINTERS */
call writeln(.ofile, '')
call writeln(.ofile, 'SOFTLOGIK:PRINTERS (printer drivers)')
if exists('SoftLogik:printers') then do
    call GETFILES('softlogik:printers')
    call SAYVERS('softlogik:printers')
    end
else do
    call writeln(.ofile, '- Printers directory MISSING!')
end
return

ENGINES:
call writeln(.ofile, '')
call writeln(.ofile, 'SOFTLOGIK:ENGINES (font and text code modules)')
if exists('SoftLogik:engines') then do
    call GETFILES('softlogik:engines')
    call SAYVERS('softlogik:engines')
    end
else do
    call writeln(.ofile, '- Engines directory MISSING!')
end
return

COLORS:
call writeln(.ofile, '')
call writeln(.ofile, 'SOFTLOGIK:COLORS (color libraries)')
if exists('SoftLogik:colors') then do
    call GETFILES('softlogik:colors')
    call SAYVERS('softlogik:colors')
    end
else do
    call writeln(.ofile, '- Colors directory MISSING!')
end
return


GETTEMP:
    if ~open(.tfile, tfilename, 'R') then return 9
    temp=readln(.tfile)
    call close(.tfile)
return temp

GETFILES:
    parse arg path
    Files=showdir(path,file,'|')
    fLength=length(Files)
    nList=0
    DO WHILE fLength>0
        cLength=pos('|',Files)
        IF cLength=0 then DO
            cLength=FLength+1
            fLength=0
        END
        cFile=left(Files,cLength-1)
        eFile=right(cFile,cLength-lastpos('.',cFile))
        IF eFile~='.info' THEN DO
            nList=nList+1
            List.nList=cFile
        END
        IF FLength~=0 THEN Files=right(Files,fLength-cLength)
        fLength=fLength-cLength
    END
return

SAYVERS:
    parse arg path
    do count=1 to nlist
        if right(list.count,5)~='.info' then do
            if upper(right(list.count,8))='FONTLIST' | upper(list.count)='POSTSCRIPT.EHANDLER' | upper(right(list.count,6))='HEADER' | upper(right(list.count,10))='DICTIONARY' | upper(left(list.count,7))='PANTONE' then do
                'list "'||path||'/'list.count||'" lformat %l >'||tfilename
                ver=' '||GETTEMP()||' bytes'
            end
            else do
                'version '||path||'/'||list.count||' >'||tfilename
                temp=GETTEMP()
                parse var temp dum ver ver2 .
				if ver2='' then ver2=' '
                ver=' v'||ver||' '||ver2
            end
            call writeln(.ofile,substr('  '||list.count,1,28,'.')||ver)
        end
    end
return


SETBUSY:
    parse arg value
	ADDRESS PAGESTREAM
	setbusyrequester bh current value
	getbusyrequester bh
	if result=1 then call CLEANUP(1)
	ADDRESS COMMAND
return


CLEANUP:
	parse arg value
	call close(.ofile)
	ADDRESS PAGESTREAM
	closebusyrequester bh
	ADDRESS COMMAND
	if value=0 then do
		'multiview '||ofilename
		if rc>0 then 'amigaguide '||ofilename
	end
	'delete '||tfilename||' >NIL:'
exit
